"use strict";
exports.__esModule = true;
var string_1 = require("../primitive/string");
var number_1 = require("../primitive/number");
var boolean_1 = require("../primitive/boolean");
var custom_1 = require("../custom");
var null_1 = require("../structure/null");
var array_1 = require("../structure/array");
var object_1 = require("../structure/object");
var Parser = /** @class */ (function () {
    function Parser(value) {
        var _this = this;
        this.value = value;
        this.asString = function () { return new string_1.StringParser(_this.value); };
        this.asNumber = function () { return new number_1.NumberParser(_this.value); };
        this.asBoolean = function () { return new boolean_1.BooleanParser(_this.value); };
        this.asNull = function () { return new null_1.NullParser(_this.value); };
        this.asCustom = function (predicate) {
            return new custom_1.CustomParser(_this.value, predicate);
        };
        this.asMutableArray = function (parseElement) { return new array_1.MutableArrayParser(_this.value, parseElement); };
        this.asReadonlyArray = function (parseElement) { return new array_1.ReadonlyArrayParser(_this.value, parseElement); };
        this.asMutableObject = function (parse) { return new object_1.MutableObjectParser(_this.value, parse); };
        this.asReadonlyObject = function (parse) { return new object_1.ReadonlyObjectParser(_this.value, parse); };
    }
    return Parser;
}());
var parse = function (value) {
    return new Parser(value);
};
exports["default"] = parse;
//# sourceMappingURL=index.js.map