import { StringParser } from '../primitive/string';
import { NumberParser } from '../primitive/number';
import { BooleanParser } from '../primitive/boolean';
import { CustomParser } from '../custom';
import { NullParser } from '../structure/null';
import { MutableArrayParser, ReadonlyArrayParser } from '../structure/array';
import { MutableObjectParser, ReadonlyObjectParser } from '../structure/object';
declare class Parser {
    private readonly value;
    constructor(value: unknown);
    asString: () => StringParser;
    asNumber: () => NumberParser;
    asBoolean: () => BooleanParser;
    asNull: () => NullParser;
    asCustom: <C>(predicate: ConstructorParameters<typeof CustomParser>[1]) => CustomParser<C>;
    asMutableArray: <E>(parseElement: (a: any, index?: number | undefined, array?: any[] | undefined) => E) => MutableArrayParser<E>;
    asReadonlyArray: <E>(parseElement: (a: any, index?: number | undefined, array?: any[] | undefined) => E) => ReadonlyArrayParser<E>;
    asMutableObject: <O extends Object>(parse: (element: any) => O) => MutableObjectParser<O>;
    asReadonlyObject: <O extends Object>(parse: (element: any) => O) => ReadonlyObjectParser<O>;
}
declare const parse: (value: ConstructorParameters<typeof Parser>[0]) => Parser;
export default parse;
