declare type Throw = Readonly<{
    message: string;
    ifParsingFailThen: 'throw';
}>;
declare type Get<T> = Readonly<{
    alternativeValue: T;
    ifParsingFailThen: 'get';
}>;
declare type LazyGet<T> = Readonly<{
    alternativeValue: () => T;
    ifParsingFailThen: 'lazy-get';
}>;
declare type Action<T> = Throw | Get<T> | LazyGet<T>;
declare const determineAction: <T>(b: Action<T>) => T;
export { determineAction };
export { Throw, Get, Action, LazyGet };
