import Parser from '../class/abstract';
import { Get, LazyGet, Throw } from '../function/action';
declare type B = boolean;
declare type BooleanOptions = Readonly<{
    boolean: unknown;
}>;
declare function parseAsBoolean(options: Throw & BooleanOptions): B;
declare function parseAsBoolean<T>(options: (Get<T> | LazyGet<T>) & BooleanOptions): T | B;
declare class BooleanParser extends Parser<B> {
    constructor(value: unknown);
    elseGet: <A>(alternativeValue: A) => boolean | A;
    elseLazyGet: <A>(alternativeValue: () => A) => boolean | A;
    elseThrow: (message: string) => B;
}
export { BooleanParser, parseAsBoolean };
