import Parser from '../class/abstract';
import { Get, LazyGet, Throw } from '../function/action';
import { RangeOf } from '../helper';
declare type N = number;
declare type NumberOptions = Readonly<{
    number: unknown;
    inRangeOf?: RangeOf;
}>;
declare function parseAsNumber(options: Throw & NumberOptions): N;
declare function parseAsNumber<T>(options: (Get<T> | LazyGet<T>) & NumberOptions): T | N;
declare class NumberParser extends Parser<N> {
    private range;
    constructor(value: unknown);
    readonly inRangeOf: (rangeOf: RangeOf) => this;
    elseThrow: (message: string) => N;
    elseGet: <A>(alternativeValue: A) => number | A;
    elseLazyGet: <A>(alternativeValue: () => A) => number | A;
}
export { NumberParser, parseAsNumber };
