import Parser from '../class/abstract';
import { Get, LazyGet, Throw } from '../function/action';
import { RangeOf } from '../helper';
declare type S = string;
declare type StringOptions = Readonly<{
    string: unknown;
    numberOfCharactersInRangeOf?: RangeOf;
}>;
declare function parseAsString(options: Throw & StringOptions): S;
declare function parseAsString<T>(options: (Get<T> | LazyGet<T>) & StringOptions): T | S;
declare class StringParser extends Parser<S> {
    private range;
    constructor(value: any);
    readonly numberOfCharactersInRangeOf: (rangeOf: RangeOf) => this;
    elseThrow: (message: string) => S;
    elseGet: <A>(alternativeValue: A) => string | A;
    elseLazyGet: <A>(alternativeValue: () => A) => string | A;
}
export { StringParser, parseAsString };
