import Parser from '../class/abstract';
import { Get, LazyGet, Throw } from '../function/action';
declare type ArrayOptions<R> = Readonly<{
    array: unknown;
    parseElement: (a: any, index?: number, array?: Array<any>) => R;
}>;
declare function parseAsMutableArray<R>(p: Throw & ArrayOptions<R>): Array<R>;
declare function parseAsMutableArray<R, T>(p: (Get<T> | LazyGet<T>) & ArrayOptions<R>): T | Array<R>;
declare function parseAsReadonlyArray<R>(p: Throw & ArrayOptions<R>): ReadonlyArray<R>;
declare function parseAsReadonlyArray<R, T>(p: (Get<T> | LazyGet<T>) & ArrayOptions<R>): T | ReadonlyArray<R>;
declare type Parse<E> = ArrayOptions<E>['parseElement'];
declare abstract class ArrayParser<E> extends Parser<ReadonlyArray<E>> {
    protected readonly parseElement: Parse<E>;
    constructor(value: any, parseElement: Parse<E>);
}
declare class ReadonlyArrayParser<E> extends ArrayParser<E> {
    constructor(array: any, parseElement: Parse<E>);
    elseGet: <A>(alternativeValue: A) => readonly E[] | A;
    elseLazyGet: <A>(alternativeValue: () => A) => readonly E[] | A;
    elseThrow: (message: string) => ReadonlyArray<E>;
}
declare class MutableArrayParser<E> extends ArrayParser<E> {
    constructor(array: any, parseElement: Parse<E>);
    elseGet: <A>(alternativeValue: A) => A | E[];
    elseLazyGet: <A>(alternativeValue: () => A) => E[] | A;
    elseThrow: (message: string) => Array<E>;
}
export { MutableArrayParser, parseAsMutableArray, ReadonlyArrayParser, parseAsReadonlyArray, };
