import Parser from '../class/abstract.js';
import { determineAction, } from '../function/action.js';
function parseAsBoolean(options) {
    return typeof options.boolean === 'boolean'
        ? options.boolean
        : determineAction(options);
}
class BooleanParser extends Parser {
    constructor(value) {
        super(value);
    }
    elseGet = (alternativeValue) => parseAsBoolean({
        alternativeValue,
        boolean: this.value,
        ifParsingFailThen: 'get',
    });
    elseLazyGet = (alternativeValue) => parseAsBoolean({
        alternativeValue,
        boolean: this.value,
        ifParsingFailThen: 'lazy-get',
    });
    elseThrow = (message) => parseAsBoolean({
        message,
        boolean: this.value,
        ifParsingFailThen: 'throw',
    });
}
export { BooleanParser, parseAsBoolean };
parseAsBoolean({
    alternativeValue: () => '',
    boolean: '',
    ifParsingFailThen: 'lazy-get',
});
//# sourceMappingURL=boolean.js.map