import Parser from '../class/abstract.js';
import { determineAction, } from '../function/action.js';
import { inRangeOf, isInRangeOf } from '../helper/index.js';
function parseAsString(options) {
    if (typeof options.string !== 'string') {
        return determineAction(options);
    }
    if (!options.numberOfCharactersInRangeOf) {
        return options.string;
    }
    return isInRangeOf({
        ...inRangeOf(options.numberOfCharactersInRangeOf),
        value: options.string.length,
    })
        ? options.string
        : determineAction(options);
}
class StringParser extends Parser {
    range;
    constructor(value) {
        super(value);
    }
    numberOfCharactersInRangeOf = (rangeOf) => {
        this.range = inRangeOf(rangeOf);
        return this;
    };
    elseThrow = (message) => parseAsString({
        message,
        string: this.value,
        ifParsingFailThen: 'throw',
        numberOfCharactersInRangeOf: this.range,
    });
    elseGet = (alternativeValue) => parseAsString({
        alternativeValue,
        string: this.value,
        ifParsingFailThen: 'get',
        numberOfCharactersInRangeOf: this.range,
    });
    elseLazyGet = (alternativeValue) => parseAsString({
        alternativeValue,
        string: this.value,
        ifParsingFailThen: 'lazy-get',
        numberOfCharactersInRangeOf: this.range,
    });
}
export { StringParser, parseAsString };
//# sourceMappingURL=string.js.map