import Parser from '../class/abstract.js';
import { determineAction, } from '../function/action.js';
function parseAsNull(b) {
    return b.value === null ? b.value : determineAction(b);
}
class NullParser extends Parser {
    constructor(value) {
        super(value);
    }
    elseGet = (alternativeValue) => parseAsNull({
        alternativeValue,
        value: this.value,
        ifParsingFailThen: 'get',
    });
    elseLazyGet = (alternativeValue) => parseAsNull({
        alternativeValue,
        value: this.value,
        ifParsingFailThen: 'lazy-get',
    });
    elseThrow = (message) => parseAsNull({
        message,
        value: this.value,
        ifParsingFailThen: 'throw',
    });
}
export { NullParser, parseAsNull };
//# sourceMappingURL=null.js.map